
/* wasp.c */
int main ( int argc , char **argv );
void usage ( void );
void initvars ( void );
void *cmalloc ( unsigned int n );
void *ccalloc ( unsigned int n );
void *crealloc ( void *q , unsigned int n );
void lowcase ( char *s );
unsigned long ceillog2 ( unsigned long a );
int stringcode ( char *s );
void do_options ( int argc , char **argv );
void do_operations ( int argc , char **argv );

/* raw.c */
int read_srgr ( void );
void write_srgr ( void );

/* readiff.c */
int read_iff ( void );
char *idstr ( unsigned long id );
void do_chunk ( unsigned long id );
int isgroupid ( unsigned long id );
int isgroupid2 ( unsigned long i , unsigned long i2 );
int isvalid ( unsigned long id );
void do_anno ( unsigned long size );
void do_cmap ( unsigned long size );
void extend_cmap ( void );
void do_sham ( unsigned long size , int is_ctbl );
void do_body ( unsigned long size );
void set_bodylimit ( unsigned long size );
void check_bodylimit ( void );
short nextbody ( void *buf );
void read_direct_body ( void );
void read_body ( void );
void fill_conv ( void );
void do_row ( short y , unsigned char *parrow );
void do_row_ham ( short y , unsigned char *parrow );
void do_row_direct ( short y , unsigned char *inrow );

/* readgif.c */
int read_gif ( void );
int readscreendescriptor ( void );
int readimagedescriptor ( void );
void readcolormap ( void );
void readbody ( void );
short nextrow ( int mode );
void decompress ( void );
short fill_masks ( short startbit , short nbits );
short nextcodes ( void );
short nextubytes ( void );
void fill_transchars ( void );

/* readras.c */
int read_ras ( void );
void read_normal ( void );
void read_compressed ( void );

/* ppm.c */
int read_ppm ( void );
void write_ppm ( void );
int getn ( char terminator );
void putn ( int n );
int read_hl ( void );
int read_mtv ( void );
void read_rgb24 ( void );
void read_grey8 ( void );
void write_rgb24 ( void );

/* operations.c */
void scalex ( int t , int n );
void scaley ( int t , int n );
void scalef ( int yflag , float factor );
void do_clipping ( int minx , int maxx , int miny , int maxy );
void do_enlarge ( int newxsz , int newysz );
void xaverage ( void );
void xmirror ( void );
void ymirror ( void );
void transpose ( void );
void testpat ( int testx , int testy );

/* io.c */
void copen_in ( char *filename );
void copen_out ( char *filename );
long cseek_in ( long offset , int whence );
long cseek_out ( long offset , int whence );
int read1 ( void *buf , int len );
void cread ( void *buf , int len );
void cwrite ( void *buf , int len );
void wrl ( unsigned long l );
void wrs ( unsigned short s );
void cout_tmp ( void );
void cout_default ( long *tmp_num , long *tmp_size );
void ctmp_move ( long tmp_num );
int printe ( char *s , ...);
void pute ( char c );
void init_counter ( int start , int end , int instep , char *s , ...);
void counter ( void );
void erase_counter ( char *s , ...);
void prin1 ( char *p );
void errorx ( long code , ...);

/* wriff.c */
void write_iff ( void );
void wriff_init ( void );
void decide_mode ( void );
int is_ehb_distr ( void );
void compute_nregs ( void );
void write_header ( void );
void write_cmap ( void );
void write_mmap ( void );
void write_1pchg ( void );
void write_body ( void );
void write_1body ( void );
void fillconv ( void );
int cmpcolregs ( short *p1 , short *p2 );
void sort_cm ( void );
char *slicednam ( int i );
char *xmodenam ( int i );
char *ymodenam ( int i );
char *dmethnam ( int i );
int dmethnum ( char *s );
char *cmethnam ( int i );
int cmethnum ( char *s );
char *mmapnam ( int i );

/* wriffcount.c */
void clear_counts ( void );
void fill_xor_tab ( void );
void call1 ( int row );
void calldif ( int row );
void callfixdif ( int row );
void cjump1 ( int row );
void cjump21 ( int row );
void cjumpdif ( int row );
void cjumpdifsh ( int row );
void cjumpfixdif ( int row );
void cjumpfixdifsh ( int row );
void chammap ( int row );
void fill_curcm ( short meth );
int count_colors ( unsigned long thr );
void count_pixels ( int firstrow , int lastrow , int moverride );

/* wriffdistr.c */
void compute_distr ( int firstrow , int lastrow );
void no_distr ( void );
void mostused_distr ( void );
void worstfirst_distr ( void );
void fill_wf_rgb ( void );
void find_2_furthest ( short *rgb1p , short *rgb2p );
void fill_wf_dist_1 ( short color );
void fill_wf_dist_2 ( short color );
void find_1_furthest ( short *rgbp );
void fill_wf2rgbweight ( void );
void wf2_redo_curcm ( void );
void black_darkest ( void );
void ehb_distr ( void );
void ehb_pair ( short c1 , int i );
void ehb_worst ( short col1 , short col8 , short *worstp );
int ehb_farcol ( short color );
void ehb_minind_adjust ( int from , int to );
void ehb_redo_curcm ( void );
void mue_distr ( void );
void mue_extend ( void );
void hamsharp_distr ( void );
void fill_hsmark ( void );
int cmphs ( struct hs_t *p1 , struct hs_t *p2 );
void fill_hshead ( void );
void fill_hs_cm ( void );
void contraction_distr ( void );
void fill_ctrgbw ( void );
void fill_cthead ( void );
void do_contraction ( void );
void fill_ct_cm ( void );
void fill_cmrgb ( void );
void fill_newcol ( void );
void fill_newcol_count ( void );
void restrict_cm ( void );

/* wriffout.c */
void row_out ( int row );
void rgb_row_out ( int row );
void rgb_line ( int y , unsigned char *inq , int bitnum );
void ham_row_out ( int row );
void fill_prgbtab ( void );
unsigned char *next_row ( int flush );
void cwritec ( int inlen );

/* wriffasm.c */

/* scrsz.c */
void get_scr_size ( void );

/* version.c */
